# generated by datamodel-codegen:
#   filename:  hatch.json
#   timestamp: 2024-11-17T16:22:13+00:00

from __future__ import annotations

from enum import Enum
from typing import Any, Dict, List

from pydantic import BaseModel, Extra, Field


class Platform(Enum):
    linux = 'linux'
    windows = 'windows'
    macos = 'macos'


class Format(BaseModel):
    config_path: str | None = Field(
        None,
        alias='config-path',
        description='Path to default configuration',
        title='Config-Path',
    )


class Metadata(BaseModel):
    allow_direct_references: bool | None = Field(
        None,
        alias='allow-direct-references',
        description='Whether to allow direct references',
        title='Allow-Direct-References',
    )
    allow_ambiguous_features: bool | None = Field(
        None,
        alias='allow-ambiguous-features',
        description='Whether to allow ambiguous features',
        title='Allow-Ambiguous-Features',
    )


class Override(BaseModel):
    __root__: Any = Field(..., description='TODO', title='Override')


class Overrides(BaseModel):
    platform: Dict[str, Override] | None = None


class Env(BaseModel):
    template: str | None = Field(
        'default',
        description='Template environment to inherit from. Set to own name to make self referential (disable inheritance from “default”)',
        title='Template',
    )
    detached: bool | None = Field(
        False,
        description='Make the environment self-referential and skip project install',
        title='Detached',
    )
    dependencies: List[str] | None = Field(
        None,
        description='List of dependencies to install in the environment',
        title='Dependencies',
    )
    extra_dependencies: List[str] | None = Field(
        None,
        alias='extra-dependencies',
        description='List of extra dependencies to install in the environment in addition to the template environment’s dependencies',
        title='Extra dependencies',
    )
    features: List[str] | None = Field(
        None,
        description='List of optional dependency groups (extras) to install',
        title='Features (extras)',
    )
    dev_mode: bool | None = Field(
        True,
        alias='dev-mode',
        description='Whether to install the project in development mode',
        title='Dev mode',
    )
    skip_install: bool | None = Field(
        False,
        alias='skip-install',
        description='Whether to skip installing the project',
        title='Skip install',
    )
    env_vars: Dict[str, str] | None = Field(
        None,
        alias='env-vars',
        description='Environment variables to set',
        title='Environment variables',
    )
    env_include: List[str] | None = Field(
        None,
        alias='env-include',
        description='Glob patterns of environment variables to include',
        title='Environment variable include',
    )
    env_exclude: List[str] | None = Field(
        None,
        alias='env-exclude',
        description='Glob patterns of environment variables to exclude',
        title='Environment variable exclude',
    )
    scripts: Dict[str, str | List[str]] | None = Field(
        None, description='Dictionary of scripts to run', title='Scripts',
    )
    pre_install_commands: List[str] | None = Field(
        None,
        alias='pre-install-commands',
        description='List of commands to run before installing the project',
        title='Pre-install commands',
    )
    post_install_commands: List[str] | None = Field(
        None,
        alias='post-install-commands',
        description='List of commands to run after installing the project',
        title='Post-install commands',
    )
    python: str | None = Field(
        None,
        description='Python version to use or an absolute path to a python interpreter',
        title='Python version',
    )
    platforms: List[Platform] | None = Field(
        None, description='List of platforms to build for', title='Platforms',
    )
    description: str | None = Field(
        None,
        description='Description of the environment for the `env show` command',
        title='Description',
    )
    type: str | None = Field(
        'virtual',
        description='Type of environment. Without plugins, the only supported type is "virtual"',
        title='Type',
    )
    matrix: List[Dict[str, List[str]]] | None = Field(
        None, description='Matrix of environments', title='Matrix',
    )
    matrix_name_format: str | None = Field(
        '{value}',
        alias='matrix-name-format',
        description='Format string for matrix names, supporting {variable} and {value} placeholders',
        title='Matrix name format',
    )
    overrides: Overrides | None = None
    requires: List[str] | None = Field(
        None, description='Required environment plugins', title='Requires',
    )


class Envs(BaseModel):
    __root__: Dict[str, Env] | None = None


class CollectorEnv(BaseModel):
    collectors: Dict[str, Dict[str, Any]] | None = Field(
        None, description='Custom environment collectors', title='Collectors',
    )
    requires: List[str] | None = Field(
        None,
        description='Required environment collectors for automatic management',
        title='Requires',
    )


class Target(BaseModel):
    dependencies: List[str] | None = Field(
        None,
        description='Additional dependencies to install in the environment',
        title='Dependencies',
    )
    require_runtime_dependencies: bool | None = Field(
        False,
        alias='require-runtime-dependencies',
        description='Whether to install the project’s runtime dependencies',
        title='Require runtime dependencies',
    )
    require_runtime_features: List[str] | None = Field(
        None,
        alias='require-runtime-features',
        description='A list of the project’s runtime features to install',
        title='Required runtime features',
    )
    versions: List[str] | None = Field(
        None, description='List of versions to build', title='Versions',
    )


class CustomTargets(BaseModel):
    __root__: Dict[str, Target] | None = None


class Hook(BaseModel):
    dependencies: List[str] | None = Field(
        None,
        description='Additional dependencies installed in the build environment',
        title='Dependencies',
    )
    require_runtime_dependencies: bool | None = Field(
        False,
        alias='require-runtime-dependencies',
        description='Whether to install the project’s runtime dependencies',
        title='Require runtime dependencies',
    )
    require_runtime_features: List[str] | None = Field(
        None,
        alias='require-runtime-features',
        description='A list of the project’s runtime features to install',
        title='Required runtime features',
    )
    enable_by_default: bool | None = Field(
        True,
        alias='enable-by-default',
        description='Whether to enable current hook (disable to control activation using environment variables)',
        title='Conditional execution',
    )


class Hooks(BaseModel):
    __root__: Dict[str, Hook] | None = None


class Build1(BaseModel):
    ignore_vcs: bool | None = Field(
        False,
        alias='ignore-vcs',
        description='Whether to ignore VCS .*ignore files and include those files by default',
        title='Ignore VCS in file selection',
    )
    include: List[str] | None = Field(
        None,
        description='List of glob patterns to include files',
        title='Include files',
    )
    exclude: List[str] | None = Field(
        None,
        description='List of glob patterns to exclude files',
        title='Exclude files',
    )
    artifacts: List[str] | None = Field(
        None,
        description='List of glob patterns to include VCS-ignored files',
        title='Artifact files',
    )
    only_packages: bool | None = Field(
        False,
        alias='only-packages',
        description='Whether to only include non-artifact files in packages',
        title='Excluding files outside packages',
    )
    sources: Dict[str, str] | List[str] | None = Field(
        None, description='Rewrite relative paths', title='Sources',
    )
    skip_excluded_dirs: bool | None = Field(
        False,
        alias='skip-excluded-dirs',
        description='Whether to skip excluded directories (for performance reasons)',
        title='Skip excluded dirs',
    )
    reproducible: bool | None = Field(
        True, description='Whether to make the build reproducible', title='Reproducible',
    )
    directory: str | None = Field(
        'dist',
        description='Directory to write build artifacts to',
        title='Output directory',
    )
    dev_mode_dirs: Any | None = Field(None, alias='dev-mode-dirs')
    dev_mode_exact: bool | None = Field(
        None,
        alias='dev-mode-exact',
        description='Whether to use an exact dev mode that doesn’t add whole directories to PYTHONPATH',
        title='Exact dev mode',
    )
    targets: CustomTargets | None = None
    hooks: Hooks | None = None


class Build2(BaseModel):
    ignore_vcs: bool | None = Field(
        False,
        alias='ignore-vcs',
        description='Whether to ignore VCS .*ignore files and include those files by default',
        title='Ignore VCS in file selection',
    )
    include: List[str] | None = Field(
        None,
        description='List of glob patterns to include files',
        title='Include files',
    )
    exclude: List[str] | None = Field(
        None,
        description='List of glob patterns to exclude files',
        title='Exclude files',
    )
    artifacts: List[str] | None = Field(
        None,
        description='List of glob patterns to include VCS-ignored files',
        title='Artifact files',
    )
    only_packages: bool | None = Field(
        False,
        alias='only-packages',
        description='Whether to only include non-artifact files in packages',
        title='Excluding files outside packages',
    )
    sources: Dict[str, str] | List[str] | None = Field(
        None, description='Rewrite relative paths', title='Sources',
    )
    skip_excluded_dirs: bool | None = Field(
        False,
        alias='skip-excluded-dirs',
        description='Whether to skip excluded directories (for performance reasons)',
        title='Skip excluded dirs',
    )
    reproducible: bool | None = Field(
        True, description='Whether to make the build reproducible', title='Reproducible',
    )
    directory: str | None = Field(
        'dist',
        description='Directory to write build artifacts to',
        title='Output directory',
    )
    dev_mode_dirs: List[str] | None = Field(
        None,
        alias='dev-mode-dirs',
        description='List of directories to add to PYTHONPATH in development mode',
        title='Dev mode directories',
    )
    dev_mode_exact: Any | None = Field(None, alias='dev-mode-exact')
    targets: CustomTargets | None = None
    hooks: Hooks | None = None


class Build(BaseModel):
    __root__: Build1 | Build2 = Field(
        ..., description='Build configuration', title='Build',
    )


class Version(BaseModel):
    path: str | None = Field(
        None,
        description='A relative path to a file containing the project version',
        title='Path',
    )
    pattern: str | None = Field(
        None, description='A regex pattern to extract the version', title='Pattern',
    )


class Repos(BaseModel):
    main: Any | None = None
    test: Any | None = None


class PublishIndex(BaseModel):
    disable: bool | None = Field(
        False,
        description='Ask for confirmation when publishing to index',
        title='Confirmation',
    )
    repos: Repos | None = Field(
        None,
        description='Define named repositories to publish to',
        title='Repositories',
    )


class Publish(BaseModel):
    index: PublishIndex | None = None


class Hatch1(BaseModel):
    class Config:
        extra = Extra.forbid

    metadata: Metadata | None = None
    env: CollectorEnv | None = None
    envs: Envs | None = None
    build: Build | None = None
    version: Any | None = None
    publish: Publish | None = None


class Hatch2(BaseModel):
    class Config:
        extra = Extra.forbid

    metadata: Metadata | None = None
    env: CollectorEnv | None = None
    envs: Envs | None = None
    build: Build | None = None
    version: Version
    publish: Publish | None = None


class Hatch(BaseModel):
    class Config:
        extra = Extra.forbid

    __root__: Hatch1 | Hatch2 = Field(..., title='Hatch')
